---
policy: /ce/ca/aws/sagemaker/notebook-instance-encryption-with-cmk
logic: /ce/ca/aws/sagemaker/notebook-instance-encryption-with-cmk/prod.logic.yaml
executionTime: 2025-11-20T13:28:59.949343139Z
generationMs: 54
executionMs: 526
rows:
  - id: test1
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10A1__kmsKeyId__c').isEmpty()
      actual: extract('CA10A1__kmsKeyId__c').isEmpty()
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 300
      actual: 300
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10A1__disappearanceTime__c)
      actual: isDisappeared(CA10A1__disappearanceTime__c)
    runtimeError: {}
  - id: test4
    match: true
    status:
      expected: INAPPLICABLE
      actual: INAPPLICABLE
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10A1__status__c') != 'InService'
      actual: extract('CA10A1__status__c') != 'InService'
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/sagemaker/notebook-instance-encryption-with-cmk/policy.yaml
    md5Hash: 1D30566440BB9537EECFB0371BE60326
    content: "---\nnames:\n  full: \"AWS SageMaker Notebook Instance is not encrypted\
      \ with a Customer-Managed KMS key\"\n  contextual: \"Notebook Instance is not\
      \ encrypted with a Customer-Managed KMS key\"\ndescription: >\n  Ensure that\
      \ AWS SageMaker Notebook Instances are encrypted with a Customer-Managed \n\
      \  KMS Key (CMK) to enhance data security and control. Using CMKs allows you\
      \ to manage \n  the lifecycle of the encryption keys, including rotation and\
      \ access policies, \n  providing an additional layer of protection for data\
      \ stored on the instance's volume.\ntype: \"COMPLIANCE_POLICY\"\ncategories:\n\
      \  - \"SECURITY\"\nframeworkMappings:\n  - \"/frameworks/cloudaware/resource-security/data-encryption\"\
      \n  - \"/frameworks/aws-well-architected/sec/08/02\"\nsimilarPolicies:\n  cloudConformity:\n\
      \    - url: \"https://www.trendmicro.com/cloudoneconformity/knowledge-base/aws/SageMaker/notebook-data-encrypted-with-kms-customer-master-keys.html\"\
      \n      name: \"Notebook Data Encrypted With KMS Customer Managed Keys\""
  - path: /ce/ca/aws/sagemaker/notebook-instance-encryption-with-cmk/prod.logic.yaml
    md5Hash: 76FA3745C1B316289AAE48149AB4C387
    content: |-
      ---
      inputType: "CA10A1__CaAwsSageMakerNotebookInstance__c"
      testData:
        - file: "test-data.json"
      importExtracts:
        - file: "/types/CA10A1__CaAwsSageMakerNotebookInstance__c/object.extracts.yaml"
      conditions:
        - status: "INAPPLICABLE"
          currentStateMessage: "The SageMaker Notebook Instance is not in service."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10A1__status__c"
              right:
                TEXT: "InService"
        - status: "INCOMPLIANT"
          currentStateMessage: "The SageMaker Notebook Instance is not encrypted with a Customer-Managed KMS Key."
          remediationMessage: "Configure the SageMaker Notebook Instance to use a Customer-Managed KMS Key for encryption."
          check:
            IS_EMPTY:
              arg:
                EXTRACT: "CA10A1__kmsKeyId__c"
      otherwise:
        status: "COMPLIANT"
        currentStateMessage: "The SageMaker Notebook Instance is encrypted with a Customer-Managed KMS Key."
  - path: /ce/ca/aws/sagemaker/notebook-instance-encryption-with-cmk/test-data.json
    md5Hash: 229CDB9E3DC65DFE39DD9F2E13E12ADB
    content: |-
      [
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "299",
                  "conditionText": "extract('CA10A1__kmsKeyId__c').isEmpty()",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-11-09T19:32:58Z"
              },
              "CA10A1__disappearanceTime__c": null,
              "CA10A1__status__c": "InService",
              "CA10A1__kmsKeyId__c": "",
              "Id": "test1"
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "300",
                  "conditionText": "otherwise",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-11-09T19:32:58Z"
              },
              "CA10A1__disappearanceTime__c": null,
              "CA10A1__status__c": "InService",
              "CA10A1__kmsKeyId__c": "kmsKeyId",
              "Id": "test2"
          },
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10A1__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-11-09T19:32:58Z"
              },
              "CA10A1__disappearanceTime__c": "2025-11-09T19:32:58Z",
              "CA10A1__status__c": "InService",
              "CA10A1__kmsKeyId__c": "kmsKeyId",
              "Id": "test3"
          },
          {
              "expectedResult": {
                  "status": "INAPPLICABLE",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10A1__status__c') != 'InService'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-11-09T19:32:58Z"
              },
              "CA10A1__disappearanceTime__c": null,
              "CA10A1__status__c": "Stopped",
              "CA10A1__kmsKeyId__c": "kmsKeyId",
              "Id": "test4"
          }
      ]
  - path: /types/CA10A1__CaAwsSageMakerNotebookInstance__c/object.extracts.yaml
    md5Hash: 560906A0F8263068277FF3F3DDCCFB02
    content: "---\nextracts:\n# Nullable.\n  - name: CA10A1__kmsKeyId__c\n    value:\n\
      \      FIELD: \n        path: CA10A1__kmsKeyId__c\n# Values: Pending | InService\
      \ | Stopping | Stopped | Failed | Deleting | Updating. Not nullable\n  - name:\
      \ CA10A1__status__c\n    value:\n      FIELD: \n        path: CA10A1__status__c\n"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "extract('CA10A1__kmsKeyId__c').isEmpty()",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "300",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10A1__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test4",
    "expectedResult" : {
      "status" : "INAPPLICABLE",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10A1__status__c') != 'InService'",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10A1__CaAwsSageMakerNotebookInstance__c()
  RETURNS ARRAY<STRUCT<
      CA10A1__disappearanceTime__c TIMESTAMP,
      CA10A1__status__c STRING,
      CA10A1__kmsKeyId__c STRING,
      Id STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-11-09T19:32:58Z")
    },
    "CA10A1__status__c" : "InService",
    "CA10A1__kmsKeyId__c" : "",
    "Id" : "test1"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-11-09T19:32:58Z")
    },
    "CA10A1__status__c" : "InService",
    "CA10A1__kmsKeyId__c" : "kmsKeyId",
    "Id" : "test2"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-11-09T19:32:58Z")
    },
    "CA10A1__disappearanceTime__c" : new Date("2025-11-09T19:32:58Z"),
    "CA10A1__status__c" : "InService",
    "CA10A1__kmsKeyId__c" : "kmsKeyId",
    "Id" : "test3"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-11-09T19:32:58Z")
    },
    "CA10A1__status__c" : "Stopped",
    "CA10A1__kmsKeyId__c" : "kmsKeyId",
    "Id" : "test4"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10A1__CaAwsSageMakerNotebookInstance__c(
      obj STRUCT<
          CA10A1__disappearanceTime__c TIMESTAMP,
          CA10A1__status__c STRING,
          CA10A1__kmsKeyId__c STRING,
          Id STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
  var TextLib = new function () {
      this.normalize = function(arg) {
          return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
      };
      this.isEmpty = function(arg) {
          return this.normalize(arg) == '';
      };
      this.isNotEmpty = function(arg) {
          return this.normalize(arg) != '';
      };
      this.equal = function(left, right) {
          return this.normalize(left) == this.normalize(right);
      };
      this.notEqual = function(left, right) {
          return this.normalize(left) != this.normalize(right);
      };
      this.startsWith = function(arg, substring) {
          return this.normalize(arg).startsWith(this.normalize(substring));
      };
      this.endsWith = function(arg, substring) {
          return this.normalize(arg).endsWith(this.normalize(substring));
      };
      this.contains = function(arg, substring) {
          return this.normalize(arg).includes(this.normalize(substring));
      };
      this.containsAll = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
      };
      this.containsAny = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
      };
  }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10A1__disappearanceTime__c]: ' + obj.CA10A1__disappearanceTime__c);
      if (obj.CA10A1__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10A1__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function extract3() { if (!this.out) { this.out = obj.CA10A1__status__c; } return this.out; };
      references1.push('Status [obj.CA10A1__status__c]: ' + obj.CA10A1__status__c);
      if (TextLib.notEqual(extract3.call(extract3), 'InService')) {
          return {status: 'INAPPLICABLE', conditionIndex: 199, conditionText: "extract('CA10A1__status__c') != 'InService'", currentStateMessage: "The SageMaker Notebook Instance is not in service.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[2], conditionIndex:[200..299]
      function extract6() { if (!this.out) { this.out = obj.CA10A1__kmsKeyId__c; } return this.out; };
      references1.push('KMS Key ID [obj.CA10A1__kmsKeyId__c]: ' + obj.CA10A1__kmsKeyId__c);
      if (TextLib.isEmpty(extract6.call(extract6))) {
          return {status: 'INCOMPLIANT', conditionIndex: 299, conditionText: "extract('CA10A1__kmsKeyId__c').isEmpty()", currentStateMessage: "The SageMaker Notebook Instance is not encrypted with a Customer-Managed KMS Key.", currentStateReferences: references1.join('\n'), remediation: "Configure the SageMaker Notebook Instance to use a Customer-Managed KMS Key for encryption.", runtimeError: null};
      }
      return {status: 'COMPLIANT', conditionIndex: 300, conditionText: "otherwise", currentStateMessage: "The SageMaker Notebook Instance is encrypted with a Customer-Managed KMS Key.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.CA10A1__disappearanceTime__c AS CA10A1__disappearanceTime__c,
          sObject.CA10A1__status__c AS CA10A1__status__c,
          sObject.CA10A1__kmsKeyId__c AS CA10A1__kmsKeyId__c,
          sObject.Id AS Id,
          process_CA10A1__CaAwsSageMakerNotebookInstance__c(
              STRUCT(
                  sObject.CA10A1__disappearanceTime__c AS CA10A1__disappearanceTime__c,
                  sObject.CA10A1__status__c AS CA10A1__status__c,
                  sObject.CA10A1__kmsKeyId__c AS CA10A1__kmsKeyId__c,
                  sObject.Id AS Id
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10A1__CaAwsSageMakerNotebookInstance__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
